## org.apache.taglibs.standard.lang.jstl.test
Class PageContextImpl

    java.lang.Object
      javax.servlet.jsp.JspContext
          javax.servlet.jsp.PageContext
              org.apache.taglibs.standard.lang.jstl.test.PageContextImpl

    public class PageContextImpl

extends PageContext

This is a "dummy" implementation of PageContext whose only purpose is to serve the attribute getter/setter API's.

Version:
  $Change: 181177 $$DateTime: 2001/06/26 08:45:09 $$Author: tcfujii $
Author:
  Nathan Abramson - Art Technology Group

Field Summary

Fields inherited from class javax.servlet.jsp.PageContext
`APPLICATION, APPLICATION_SCOPE, CONFIG, EXCEPTION, OUT, PAGE, PAGE_SCOPE, PAGECONTEXT, REQUEST, REQUEST_SCOPE, RESPONSE, SESSION, SESSION_SCOPE`

Constructor Summary
`PageContextImpl()` Constructor

Method Summary
`Object` `findAttribute(String name)` Searches for the named attribute in page, request, session (if valid), and application scope(s) in order and returns the value associated or null.
`void` `forward(String path)` This method is used to re-direct, or "forward" the current ServletRequest and ServletResponse to another active component in the application.
`Object` `getAttribute(String name)` Returns the object associated with the name in the page scope or null if not found.
`Object` `getAttribute(String name, int scope)` Return the object associated with the name in the specified scope or null if not found.
`Enumeration` `getAttributeNamesInScope(int scope)` Enumerate all the attributes in a given scope.
`int` `getAttributesScope(String name)` Get the scope where a given attribute is defined.
`ELContext` `getELContext()` Returns the `ELContext` associated with this `JspContext`.
`Exception` `getException()` The current value of the exception object (an Exception).
`ExpressionEvaluator` `getExpressionEvaluator()` Provides programmatic access to the ExpressionEvaluator.
`JspWriter` `getOut()` The current value of the out object (a JspWriter).
`Object` `getPage()` The current value of the page object (In a Servlet environment, this is an instance of javax.servlet.Servlet).
`ServletRequest` `getRequest()` The current value of the request object (a ServletRequest).
`ServletResponse` `getResponse()` The current value of the response object (a ServletResponse).
`ServletConfig` `getServletConfig()` The ServletConfig instance.
`ServletContext` `getServletContext()` The ServletContext instance.
`HttpSession` `getSession()` The current value of the session object (an HttpSession).
`VariableResolver` `getVariableResolver()` Returns an instance of a VariableResolver that provides access to the implicit objects specified in the JSP specification using this JspContext as the context object.
`void` `handlePageException(Exception exc)` This method is intended to process an unhandled 'page' level exception by forwarding the exception to the specified error page for this JSP.
`void` `handlePageException(Throwable exc)` This method is intended to process an unhandled 'page' level exception by forwarding the exception to the specified error page for this JSP.
`void` `include(String path)` Causes the resource specified to be processed as part of the current ServletRequest and ServletResponse being processed by the calling Thread.
`void` `include(String relativeUrlPath, boolean flush)` Causes the resource specified to be processed as part of the current ServletRequest and ServletResponse being processed by the calling Thread.
`void` `initialize(Servlet servlet, ServletRequest request, ServletResponse response, String errorPageURL, boolean needSession, int bufferSize, boolean autoFlush)` The initialize method is called to initialize an uninitialized PageContext so that it may be used by a JSP Implementation class to service an incoming request and response within it's _jspService() method.
`void` `release()` This method shall "reset" the internal state of a PageContext, releasing all internal references, and preparing the PageContext for potential reuse by a later invocation of initialize().
`void` `removeAttribute(String name)` Remove the object reference associated with the given name from all scopes.
`void` `removeAttribute(String name, int scope)` Remove the object reference associated with the specified name in the given scope.
`void` `setAttribute(String name, Object attribute)` Register the name and value specified with page scope semantics.
`void` `setAttribute(String name, Object attribute, int scope)` Register the name and value specified with appropriate scope semantics.

Methods inherited from class javax.servlet.jsp.PageContext
`getErrorData, pushBody`

Methods inherited from class javax.servlet.jsp.JspContext
`popBody, pushBody`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### PageContextImpl

    public PageContextImpl()

  Constructor

Method Detail

### initialize

    public void initialize(Servlet servlet,
                           ServletRequest request,
                           ServletResponse response,
                           String errorPageURL,
                           boolean needSession,
                           int bufferSize,
                           boolean autoFlush)

  Description copied from class: `PageContext`

  The initialize method is called to initialize an uninitialized PageContext so that it may be used by a JSP Implementation class to service an incoming request and response within it's _jspService() method.

  This method is typically called from JspFactory.getPageContext() in order to initialize state.

  This method is required to create an initial JspWriter, and associate the "out" name in page scope with this newly created object.

  This method should not be used by page or tag library authors.

  Specified by:
    `initialize` in class `PageContext`
  Parameters:
    `servlet` - The Servlet that is associated with this PageContext
    `request` - The currently pending request for this Servlet
    `response` - The currently pending response for this Servlet
    `errorPageURL` - The value of the errorpage attribute from the page directive or null
    `needSession` - The value of the session attribute from the page directive
    `bufferSize` - The value of the buffer attribute from the page directive
    `autoFlush` - The value of the autoflush attribute from the page directive

### release

    public void release()

  Description copied from class: `PageContext`

  This method shall "reset" the internal state of a PageContext, releasing all internal references, and preparing the PageContext for potential reuse by a later invocation of initialize(). This method is typically called from JspFactory.releasePageContext().

  Subclasses shall envelope this method.

  This method should not be used by page or tag library authors.

  Specified by:
    `release` in class `PageContext`

### setAttribute

    public void setAttribute(String name,
                             Object attribute)

  Description copied from class: `JspContext`
  Register the name and value specified with page scope semantics. If the value passed in is `null`, this has the same effect as calling `removeAttribute( name, PageContext.PAGE_SCOPE )`.

  Specified by:
    `setAttribute` in class `JspContext`
  Parameters:
    `name` - the name of the attribute to set
    `attribute` - the value to associate with the name, or null if the attribute is to be removed from the page scope.

### setAttribute

    public void setAttribute(String name,
                             Object attribute,
                             int scope)

  Description copied from class: `JspContext`
  Register the name and value specified with appropriate scope semantics. If the value passed in is `null`, this has the same effect as calling `removeAttribute( name, scope )`.

  Specified by:
    `setAttribute` in class `JspContext`
  Parameters:
    `name` - the name of the attribute to set
    `attribute` - the object to associate with the name, or null if the attribute is to be removed from the specified scope.
    `scope` - the scope with which to associate the name/object

### getAttribute

    public Object getAttribute(String name)

  Description copied from class: `JspContext`
  Returns the object associated with the name in the page scope or null if not found.

  Specified by:
    `getAttribute` in class `JspContext`
  Parameters:
    `name` - the name of the attribute to get
  Returns:
    the object associated with the name in the page scope or null if not found.

### getAttribute

    public Object getAttribute(String name,
                               int scope)

  Description copied from class: `JspContext`
  Return the object associated with the name in the specified scope or null if not found.

  Specified by:
    `getAttribute` in class `JspContext`
  Parameters:
    `name` - the name of the attribute to set
    `scope` - the scope with which to associate the name/object
  Returns:
    the object associated with the name in the specified scope or null if not found.

### findAttribute

    public Object findAttribute(String name)

  Description copied from class: `JspContext`
  Searches for the named attribute in page, request, session (if valid), and application scope(s) in order and returns the value associated or null.

  Specified by:
    `findAttribute` in class `JspContext`
  Parameters:
    `name` - the name of the attribute to search for
  Returns:
    the value associated or null

### removeAttribute

    public void removeAttribute(String name)

  Description copied from class: `JspContext`
  Remove the object reference associated with the given name from all scopes. Does nothing if there is no such object.

  Specified by:
    `removeAttribute` in class `JspContext`
  Parameters:
    `name` - The name of the object to remove.

### removeAttribute

    public void removeAttribute(String name,
                                int scope)

  Description copied from class: `JspContext`
  Remove the object reference associated with the specified name in the given scope. Does nothing if there is no such object.

  Specified by:
    `removeAttribute` in class `JspContext`
  Parameters:
    `name` - The name of the object to remove.
    `scope` - The scope where to look.

### getAttributesScope

    public int getAttributesScope(String name)

  Description copied from class: `JspContext`
  Get the scope where a given attribute is defined.

  Specified by:
    `getAttributesScope` in class `JspContext`
  Parameters:
    `name` - the name of the attribute to return the scope for
  Returns:
    the scope of the object associated with the name specified or 0

### getAttributeNamesInScope

    public Enumeration getAttributeNamesInScope(int scope)

  Description copied from class: `JspContext`
  Enumerate all the attributes in a given scope.

  Specified by:
    `getAttributeNamesInScope` in class `JspContext`
  Parameters:
    `scope` - the scope to enumerate all the attributes for
  Returns:
    an enumeration of names (java.lang.String) of all the attributes the specified scope

### getOut

    public JspWriter getOut()

  Description copied from class: `JspContext`
  The current value of the out object (a JspWriter).

  Specified by:
    `getOut` in class `JspContext`
  Returns:
    the current JspWriter stream being used for client response

### getSession

    public HttpSession getSession()

  Description copied from class: `PageContext`
  The current value of the session object (an HttpSession).

  Specified by:
    `getSession` in class `PageContext`
  Returns:
    the HttpSession for this PageContext or null

### getPage

    public Object getPage()

  Description copied from class: `PageContext`
  The current value of the page object (In a Servlet environment, this is an instance of javax.servlet.Servlet).

  Specified by:
    `getPage` in class `PageContext`
  Returns:
    the Page implementation class instance associated with this PageContext

### getRequest

    public ServletRequest getRequest()

  Description copied from class: `PageContext`
  The current value of the request object (a ServletRequest).

  Specified by:
    `getRequest` in class `PageContext`
  Returns:
    The ServletRequest for this PageContext

### getResponse

    public ServletResponse getResponse()

  Description copied from class: `PageContext`
  The current value of the response object (a ServletResponse).

  Specified by:
    `getResponse` in class `PageContext`
  Returns:
    the ServletResponse for this PageContext

### getException

    public Exception getException()

  Description copied from class: `PageContext`
  The current value of the exception object (an Exception).

  Specified by:
    `getException` in class `PageContext`
  Returns:
    any exception passed to this as an errorpage

### getServletConfig

    public ServletConfig getServletConfig()

  Description copied from class: `PageContext`
  The ServletConfig instance.

  Specified by:
    `getServletConfig` in class `PageContext`
  Returns:
    the ServletConfig for this PageContext

### getServletContext

    public ServletContext getServletContext()

  Description copied from class: `PageContext`
  The ServletContext instance.

  Specified by:
    `getServletContext` in class `PageContext`
  Returns:
    the ServletContext for this PageContext

### forward

    public void forward(String path)

  Description copied from class: `PageContext`

  This method is used to re-direct, or "forward" the current ServletRequest and ServletResponse to another active component in the application.

  If the relativeUrlPath begins with a "/" then the URL specified is calculated relative to the DOCROOT of the `ServletContext` for this JSP. If the path does not begin with a "/" then the URL specified is calculated relative to the URL of the request that was mapped to the calling JSP.

  It is only valid to call this method from a `Thread` executing within a `_jspService(...)` method of a JSP.

  Once this method has been called successfully, it is illegal for the calling `Thread` to attempt to modify the `ServletResponse` object. Any such attempt to do so, shall result in undefined behavior. Typically, callers immediately return from `_jspService(...)` after calling this method.

  Specified by:
    `forward` in class `PageContext`
  Parameters:
    `path` - specifies the relative URL path to the target resource as described above

### include

    public void include(String path)

  Description copied from class: `PageContext`

  Causes the resource specified to be processed as part of the current ServletRequest and ServletResponse being processed by the calling Thread. The output of the target resources processing of the request is written directly to the ServletResponse output stream.

  The current JspWriter "out" for this JSP is flushed as a side-effect of this call, prior to processing the include.

  If the relativeUrlPath begins with a "/" then the URL specified is calculated relative to the DOCROOT of the `ServletContext` for this JSP. If the path does not begin with a "/" then the URL specified is calculated relative to the URL of the request that was mapped to the calling JSP.

  It is only valid to call this method from a `Thread` executing within a `_jspService(...)` method of a JSP.

  Specified by:
    `include` in class `PageContext`
  Parameters:
    `path` - specifies the relative URL path to the target resource to be included

### handlePageException

    public void handlePageException(Exception exc)

  Description copied from class: `PageContext`

  This method is intended to process an unhandled 'page' level exception by forwarding the exception to the specified error page for this JSP. If forwarding is not possible (for example because the response has already been committed), an implementation dependent mechanism should be used to invoke the error page (e.g. "including" the error page instead).

  If no error page is defined in the page, the exception should be rethrown so that the standard servlet error handling takes over.

  A JSP implementation class shall typically clean up any local state prior to invoking this and will return immediately thereafter. It is illegal to generate any output to the client, or to modify any ServletResponse state after invoking this call.

  This method is kept for backwards compatiblity reasons. Newly generated code should use PageContext.handlePageException(Throwable).

  Specified by:
    `handlePageException` in class `PageContext`
  Parameters:
    `exc` - the exception to be handled
  See Also:
    `PageContext.handlePageException(Throwable)`

### handlePageException

    public void handlePageException(Throwable exc)

  Description copied from class: `PageContext`

  This method is intended to process an unhandled 'page' level exception by forwarding the exception to the specified error page for this JSP. If forwarding is not possible (for example because the response has already been committed), an implementation dependent mechanism should be used to invoke the error page (e.g. "including" the error page instead).

  If no error page is defined in the page, the exception should be rethrown so that the standard servlet error handling takes over.

  This method is intended to process an unhandled "page" level exception by redirecting the exception to either the specified error page for this JSP, or if none was specified, to perform some implementation dependent action.

  A JSP implementation class shall typically clean up any local state prior to invoking this and will return immediately thereafter. It is illegal to generate any output to the client, or to modify any ServletResponse state after invoking this call.

  Specified by:
    `handlePageException` in class `PageContext`
  Parameters:
    `exc` - the throwable to be handled
  See Also:
    `PageContext.handlePageException(Exception)`

### include

    public void include(String relativeUrlPath,
                        boolean flush)

  Description copied from class: `PageContext`

  Causes the resource specified to be processed as part of the current ServletRequest and ServletResponse being processed by the calling Thread. The output of the target resources processing of the request is written directly to the current JspWriter returned by a call to getOut().

  If flush is true, The current JspWriter "out" for this JSP is flushed as a side-effect of this call, prior to processing the include. Otherwise, the JspWriter "out" is not flushed.

  If the relativeUrlPath begins with a "/" then the URL specified is calculated relative to the DOCROOT of the `ServletContext` for this JSP. If the path does not begin with a "/" then the URL specified is calculated relative to the URL of the request that was mapped to the calling JSP.

  It is only valid to call this method from a `Thread` executing within a `_jspService(...)` method of a JSP.

  Specified by:
    `include` in class `PageContext`
  Parameters:
    `relativeUrlPath` - specifies the relative URL path to the target resource to be included
    `flush` - True if the JspWriter is to be flushed before the include, or false if not.

### getExpressionEvaluator

    public ExpressionEvaluator getExpressionEvaluator()

  Description copied from class: `JspContext`
  Provides programmatic access to the ExpressionEvaluator. The JSP Container must return a valid instance of an ExpressionEvaluator that can parse EL expressions.

  Specified by:
    `getExpressionEvaluator` in class `JspContext`
  Returns:
    A valid instance of an ExpressionEvaluator.

### getVariableResolver

    public VariableResolver getVariableResolver()

  Description copied from class: `JspContext`
  Returns an instance of a VariableResolver that provides access to the implicit objects specified in the JSP specification using this JspContext as the context object.

  Specified by:
    `getVariableResolver` in class `JspContext`
  Returns:
    A valid instance of a VariableResolver.

### getELContext

    public ELContext getELContext()

  Description copied from class: `JspContext`
  Returns the `ELContext` associated with this `JspContext`.

  The `ELContext` is created lazily and is reused if it already exists. There is a new `ELContext` for each `JspContext`.

  The `ELContext` must contain the `ELResolver` described in the JSP specification (and in the javadocs for `JspApplicationContext.addELResolver(javax.el.ELResolver)`).

  Specified by:
    `getELContext` in class `JspContext`
  Returns:
    The `ELContext` associated with this `JspContext`.

Copyright © 2007 Mort Bay Consulting. All Rights Reserved.